<template>
  <view-new
    :status="status"
    title="Dodaj lokalizację"
    sentTitle="Nowa lokalizacja została dodana"
    :back="BACK"
  >
    <input-form v-on:submit.prevent="on_submit">
      <input-text-field
        :error="get_error_for('name')"
        name="Nazwa"
        v-model="name"
        type="text"
        size="2"
      />
      <input-text-field
        :error="get_error_for('street')"
        name="Ulica"
        v-model="street"
        type="text"
      />
      <input-radio
        :error="get_error_for('type_id')"
        name="Rodzaj"
        v-model="type_id"
        :list="types"
      />
      <input-text-field
        :error="get_error_for('post_code')"
        name="Kod pocztowy"
        v-model="post_code"
        type="text"
      />
      <input-text-field
        :error="get_error_for('city')"
        name="Miasto"
        v-model="city"
        type="text"
      />
      <div
        v-for="error in errors.filter((e) => e.field == null)"
        :style="{ gridColumnEnd: `span 2` }"
        :key="error.error"
        class="error"
      >
        {{ error.error }}
      </div>
      <input-button
        text="Dodaj lokalizację"
        :spinner="status == formStatus.sending"
        size="2"
      />
    </input-form>
  </view-new>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import NewRecord from "@/views/new-views/NewRecord.ts";

import InputButton from "@/components/input/InputButton.vue";
import InputForm from "@/components/input/InputForm.vue";
import InputTextField from "@/components/input/InputTextField.vue";
import InputRadio from "@/components/input/InputRadio.vue";

import { LocationTypeData, NewLocationData, NewUserData } from "@/interfaces";

import ViewNew from "@/views/new-views/ViewNew.vue";
import { NApi } from "@/interfaces/connector";

@Options({
  components: {
    ViewNew,
    InputButton,
    InputForm,
    InputTextField,
    InputRadio,
  },
})
export default class NewLocation
  extends NewRecord<NewLocationData, null>
  implements NewLocationData {
  public API_CALL = NApi.newLocation;
  public BACK = "/lokalizacje";

  public name = "";
  public street = "";
  public post_code = "";
  public city = "";
  public type_id = 0;

  public types: { id: number; display_name: string }[] = [];

  public mounted() {
    this.load_location_types();
  }

  public get_data = () => ({
    name: this.name,
    street: this.street,
    post_code: this.post_code,
    city: this.city,
    type_id: this.type_id,
  });

  public load_location_types = async () => {
    try {
      const data: any[] = await NApi.getLocationTypes();

      for (const { id, name } of data) {
        this.types.push({
          id,
          display_name: name,
        });
      }
    } catch (e) {
      console.log(e);
    }
  };
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.error {
  color: $red;
  font-size: 10px;
}
</style>
